%define ocamlname websocket-lwt

Name:           ocaml-%{ocamlname}
Version:        2.11
Release:        1%{?dist}.emp1
Summary:        Websocket library
License:        Custom
URL:            https://github.com/mirage/ocaml-%{ocaml-name}
Source0:        ocaml-websocket-%{version}.tar.gz

Requires:  	ocaml >= 4.02.0
Requires:	ocaml-ipaddr >= 2.8.0
Requires:	ocaml-lwt_ssl >= 1.1.0
Requires:	ocaml-websocket = 2.10
Requires:	ocaml-cohttp-lwt-unix >= 1.0

BuildRequires:  opam-installer >= 2.0
BuildRequires:  ocaml >= 4.02.0
BuildRequires:  jbuilder
BuildRequires:	ocaml-ipaddr-devel >= 2.8.0
BuildRequires:	ocaml-lwt_ssl-devel >= 1.1.0
BuildRequires:	ocaml-websocket-devel = 2.10
BuildRequires:	ocaml-cohttp-lwt-unix-devel >= 1.0

%description
The WebSocket Protocol enables two-way communication between a client
running untrusted code in a controlled environment to a remote host
that has opted-in to communications from that code.  The security
model used for this is the origin-based security model commonly used
by web browsers.  The protocol consists of an opening handshake
followed by basic message framing, layered over TCP.  The goal of this
technology is to provide a mechanism for browser-based applications
that need two-way communication with servers that does not rely on
opening multiple HTTP connections (e.g., using XMLHttpRequest or
<iframe>s and long polling).

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:	ocaml-ipaddr-devel >= 2.8.0
Requires:	ocaml-lwt_ssl-devel >= 1.1.0
Requires:	ocaml-websocket-devel = 2.10
Requires:	ocaml-cohttp-lwt-unix-devel >= 1.0

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n ocaml-websocket-%{version}

%build
jbuilder build -p %{ocamlname} %{?_smp_mflags}

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install
mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}/%{_libdir}/ocaml/bin/* %{buildroot}/%{_bindir}/.

%files
%doc %{_libdir}/ocaml/doc/%{ocamlname}/LICENSE.md
%{_libdir}/ocaml/%{ocamlname}
%{_bindir}/*
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli

%files devel
%doc %{_libdir}/ocaml/doc/%{ocamlname}/CHANGES
%doc %{_libdir}/ocaml/doc/%{ocamlname}/README.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
